///////////////////////////////////////////////////////////////////////
//
// The contents of this file have been generated by QuickBuilder.
// To use this with your application code, carry out these steps:
//
// 1. Include this file using #include "filename" where file name
// is the filename including path. Place the #include before
// the start of you code.
//
// 2. Place a call to INIT_SUB_CIRCUITS() in the initialisation portion
// of your application code.
//
//                    www.quickbuilder.co.uk
//
//
// DO NOT MODIFY          DO NOT MODIFY         DO NOT MODIFY
//
///////////////////////////////////////////////////////////////////////



//*********************************************************************
//*                            defines                                *
//*********************************************************************
// pic16xxx.inc
#define PORTA   0x05
#define PORTB   0x06
#define PORTC   0x07
#define PORTD   0x08
#define PORTE   0x09
#define TRISA   0x85
#define TRISB   0x86
#define TRISC   0x87
#define TRISD   0x88
#define TRISE   0x89
//


// Source: define.inc
// ------------------
// asm defined
#define _Z      3,2
#define _C      3,0
#define _RP0    3,5

// qb - ccs interface
#define _PA_OUT(x)              output_a(x)
#define _PB_OUT(x)              output_b(x)
#define _PC_OUT(x)              output_c(x)
#define _PD_OUT(x)              output_d(x)
#define _PE_OUT(x)              output_e(x)
#define _PF_OUT(x)              output_f(x)

#define _PA_IN(x)               input_a(x)
#define _PB_IN(x)               input_b(x)
#define _PC_IN(x)               input_c(x)
#define _PD_IN(x)               input_d(x)
#define _PE_IN(x)               input_e(x)
#define _PF_IN(x)               input_f(x)

#define _PADR_SET(x)            set_tris_a(x)
#define _PBDR_SET(x)            set_tris_b(x)
#define _PCDR_SET(x)            set_tris_c(x)
#define _PDDR_SET(x)            set_tris_d(x)
#define _PEDR_SET(x)            set_tris_e(x)
#define _PFDR_SET(x)            set_tris_f(x)


#define _PBIT_SET(port,bit)     bit_set(*port,bit)
#define _PBIT_CLEAR(port,bit)   bit_clear(*port,bit)
#define _PBIT_IN(port,bit)      bit_test(*port,bit)

#define _BITDR_SET(tris,bit)    bit_set(*tris,bit)
#define _BITDR_CLEAR(tris,bit)  bit_clear(*tris,bit)




//
///SECTION>



//*********************************************************************
//*                           subroutines                             *
//*********************************************************************
//<SECTION SUBS
/*<********************************************************

************************************************************
*             (C) Copyright 2002-2003 mTECH                *
*  This source code may only be used by Licensees          *
*  of QuickBuilder as specified in the End User License    *
*  Agreement ("EULA")located at www.quickbuilder.co.uk.    *
*  No other use, reproduction or distribution is permitted *
*  without specific written permission from mTECH.         *
*  Derivative programmes created using this software in    *
*  object code form are not restricted.                    *
************************************************************
Rev1.0

SW_1
    Push switch with resistor pull up.

METHODS
-------
int SW_1STATE( void )
    Returns switch state: 0=up, 1=down.

int SW_1PRESSED( void )
    Returns switch pressed event: 0=not pressed, 1=pressed.

************************************************>*/
#define P_0 PORTB,3
#define TRISP_0 TRISB,3
//******************
int SW_1PRESSED()
    {
    static int1 laststate=0;

    if (!bit_test(* P_0) ) {
        delay_ms(50);   // debounce time
        if (laststate) {
            laststate = 0;
            return(1);
        }
    } else
        laststate=1;

    return (0);
}


//******************
int SW_1STATE()
    {
    if ( !bit_test(* P_0) )
        return 1;
    else
        return 0;
    }


void SW_1INIT()
    {
#asm
    BSF _RP0
    BSF TRISP_0
#endasm
    }
/*<********************************************************

************************************************************
*             (C) Copyright 2002-2003 mTECH                *
*  This source code may only be used by Licensees          *
*  of QuickBuilder as specified in the End User License    *
*  Agreement ("EULA")located at www.quickbuilder.co.uk.    *
*  No other use, reproduction or distribution is permitted *
*  without specific written permission from mTECH.         *
*  Derivative programmes created using this software in    *
*  object code form are not restricted.                    *
************************************************************
Rev1.0

SW_2
    Push switch with resistor pull up.

METHODS
-------
int SW_2STATE( void )
    Returns switch state: 0=up, 1=down.

int SW_2PRESSED( void )
    Returns switch pressed event: 0=not pressed, 1=pressed.

************************************************>*/
#define P_1 PORTB,4
#define TRISP_1 TRISB,4
//******************
int SW_2PRESSED()
    {
    static int1 laststate=0;

    if (!bit_test(* P_1) ) {
        delay_ms(50);   // debounce time
        if (laststate) {
            laststate = 0;
            return(1);
        }
    } else
        laststate=1;

    return (0);
}


//******************
int SW_2STATE()
    {
    if ( !bit_test(* P_1) )
        return 1;
    else
        return 0;
    }


void SW_2INIT()
    {
#asm
    BSF _RP0
    BSF TRISP_1
#endasm
    }
/*<********************************************************

************************************************************
*             (C) Copyright 2002-2003 mTECH                *
*  This source code may only be used by Licensees          *
*  of QuickBuilder as specified in the End User License    *
*  Agreement ("EULA")located at www.quickbuilder.co.uk.    *
*  No other use, reproduction or distribution is permitted *
*  without specific written permission from mTECH.         *
*  Derivative programmes created using this software in    *
*  object code form are not restricted.                    *
************************************************************
Rev1.0

SW_3
    Push switch with resistor pull up.

METHODS
-------
int SW_3STATE( void )
    Returns switch state: 0=up, 1=down.

int SW_3PRESSED( void )
    Returns switch pressed event: 0=not pressed, 1=pressed.

************************************************>*/
#define P_2 PORTB,5
#define TRISP_2 TRISB,5
//******************
int SW_3PRESSED()
    {
    static int1 laststate=0;

    if (!bit_test(* P_2) ) {
        delay_ms(50);   // debounce time
        if (laststate) {
            laststate = 0;
            return(1);
        }
    } else
        laststate=1;

    return (0);
}


//******************
int SW_3STATE()
    {
    if ( !bit_test(* P_2) )
        return 1;
    else
        return 0;
    }


void SW_3INIT()
    {
#asm
    BSF _RP0
    BSF TRISP_2
#endasm
    }
/*<********************************************************

************************************************************
*             (C) Copyright 2002-2003 mTECH                *
*  This source code may only be used by Licensees          *
*  of QuickBuilder as specified in the End User License    *
*  Agreement ("EULA")located at www.quickbuilder.co.uk.    *
*  No other use, reproduction or distribution is permitted *
*  without specific written permission from mTECH.         *
*  Derivative programmes created using this software in    *
*  object code form are not restricted.                    *
************************************************************
Rev1.0

SW_4
    Push switch with resistor pull up.

METHODS
-------
int SW_4STATE( void )
    Returns switch state: 0=up, 1=down.

int SW_4PRESSED( void )
    Returns switch pressed event: 0=not pressed, 1=pressed.

************************************************>*/
#define P_3 PORTB,6
#define TRISP_3 TRISB,6
//******************
int SW_4PRESSED()
    {
    static int1 laststate=0;

    if (!bit_test(* P_3) ) {
        delay_ms(50);   // debounce time
        if (laststate) {
            laststate = 0;
            return(1);
        }
    } else
        laststate=1;

    return (0);
}


//******************
int SW_4STATE()
    {
    if ( !bit_test(* P_3) )
        return 1;
    else
        return 0;
    }


void SW_4INIT()
    {
#asm
    BSF _RP0
    BSF TRISP_3
#endasm
    }
/*<********************************************************

************************************************************
*             (C) Copyright 2002-2003 mTECH                *
*  This source code may only be used by Licensees          *
*  of QuickBuilder as specified in the End User License    *
*  Agreement ("EULA")located at www.quickbuilder.co.uk.    *
*  No other use, reproduction or distribution is permitted *
*  without specific written permission from mTECH.         *
*  Derivative programmes created using this software in    *
*  object code form are not restricted.                    *
************************************************************
Rev1.0

SW_5
    Push switch with resistor pull up.

METHODS
-------
int SW_5STATE( void )
    Returns switch state: 0=up, 1=down.

int SW_5PRESSED( void )
    Returns switch pressed event: 0=not pressed, 1=pressed.

************************************************>*/
#define P_4 PORTB,7
#define TRISP_4 TRISB,7
//******************
int SW_5PRESSED()
    {
    static int1 laststate=0;

    if (!bit_test(* P_4) ) {
        delay_ms(50);   // debounce time
        if (laststate) {
            laststate = 0;
            return(1);
        }
    } else
        laststate=1;

    return (0);
}


//******************
int SW_5STATE()
    {
    if ( !bit_test(* P_4) )
        return 1;
    else
        return 0;
    }


void SW_5INIT()
    {
#asm
    BSF _RP0
    BSF TRISP_4
#endasm
    }
///SECTION>


//*********************************************************************
//*                          initialisation                           *
//*********************************************************************
void INIT_SUB_CIRCUITS()
    {
//<SECTION INIT
    SW_1INIT();
    SW_2INIT();
    SW_3INIT();
    SW_4INIT();
    SW_5INIT();
///SECTION>
    }

